;
; crosslnk.asm - Cross bank jumper
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; Generated automatically. DO NOT EDIT!
;
			.if BANK=0
append_status_dec       sta bank_port1                  ;0000 -> 0006
			jsr iecin                       ;0003 <- BANK1
exitbank1               sta bank_port1                  ;0006
			rts				;0009
call_setup              sta bank_port1                  ;000A -> 0010
			jsr ieclisten                   ;000D <- BANK1
                        sta bank_port1                  ;0010
			rts				;0013
LWOP_disk_status        sta bank_port1                  ;0014 -> 001A
			jsr iecout                      ;0017 <- BANK1
                        sta bank_port1                  ;001A
			rts				;001D
LWOP_get_cmos_setup     sta bank_port1                  ;001E -> 0024
			jsr iectalk                     ;0021 <- BANK1
                        sta bank_port1                  ;0024
			rts				;0027
LWOP_read_clock         sta bank_port1                  ;0028 -> 002E
			jsr iectksa                     ;002B <- BANK1
                        sta bank_port1                  ;002E
			rts				;0031
OP_atapi_command        sta bank_port1                  ;0032 -> 0038
			jsr iecunlisten                 ;0035 <- BANK1
                        sta bank_port1                  ;0038
			rts				;003B
OP_atapi_packet         sta bank_port1                  ;003C -> 0042
			jsr iecuntalk                   ;003F <- BANK1
                        sta bank_port1                  ;0042
			rts				;0045
OP_copy_filename_to_path sta bank_port1                  ;0046 -> 004C
			jsr iecsecond                   ;0049 <- BANK1
                        sta bank_port1                  ;004C
			rts				;004F
OP_load_loading_end     sta bank_port1                  ;0050 -> 0056
			jsr jiffy_f0d8                  ;0053 <- BANK1
                        sta bank_port1                  ;0056
			rts				;0059
OP_save_saving          sta bank_port1                  ;005A -> 0060
			jsr OP_check_partition_selection;005D <- BANK1
                        sta bank_port1                  ;0060
			rts				;0063
OP_XIT_resolv_path_part sta bank_port1                  ;0064 -> 006A
			jsr set_power_management_and_features;0067 <- BANK1
                        sta bank_port1                  ;006A
			rts				;006D
OP_atapi_datain_command sta bank_port1                  ;006E -> 0074
			jsr LWOP_timestamp              ;0071 <- BANK2
exitbank2               sta bank_port2                  ;0074
			rts				;0077
check_drive             sta bank_port2                  ;0078 -> 007E
			jsr OP_check_partition_selection;007B <- BANK2
                        sta bank_port2                  ;007E
			rts				;0081
find_free_sector        sta bank_port2                  ;0082 -> 0088
			jsr OP_init_buffer_pointers     ;0085 <- BANK2
                        sta bank_port2                  ;0088
			rts				;008B
OP_XIT_do_command_channel sta bank_port2                  ;008C -> 0092
			jsr OP_XIT_init_filesystem_from_disk;008F <- BANK2
                        sta bank_port2                  ;0092
			rts				;0095
OP_XIT_execute_15command_open sta bank_port2                  ;0096 -> 009C
			jsr search_buffer_A             ;0099 <- BANK2
                        sta bank_port2                  ;009C
			rts				;009F
rewrite_file            sta bank_port2                  ;00A0 -> 00A6
			jsr XIT_flush_buf               ;00A3 <- BANK2
                        sta bank_port2                  ;00A6
			rts				;00A9
update_filelen          sta bank_port2                  ;00AA -> 00B0
			jsr iecin                       ;00AD <- BANK3
exitbank3               sta bank_port3                  ;00B0
			rts				;00B3
cdrom_idleoff           sta bank_port3                  ;00B4 -> 00BA
			jsr ieclisten                   ;00B7 <- BANK3
                        sta bank_port3                  ;00BA
			rts				;00BD
pclink_chrin            sta bank_port3                  ;00BE -> 00C4
			jsr iecout                      ;00C1 <- BANK3
                        sta bank_port3                  ;00C4
			rts				;00C7
pclink_close            sta bank_port3                  ;00C8 -> 00CE
			jsr iectalk                     ;00CB <- BANK3
                        sta bank_port3                  ;00CE
			rts				;00D1
pclink_open             sta bank_port3                  ;00D2 -> 00D8
			jsr iectksa                     ;00D5 <- BANK3
                        sta bank_port3                  ;00D8
			rts				;00DB
pclink_save             sta bank_port3                  ;00DC -> 00E2
			jsr iecunlisten                 ;00DF <- BANK3
                        sta bank_port3                  ;00E2
			rts				;00E5
XIT_dir_first           sta bank_port3                  ;00E6 -> 00EC
			jsr iecuntalk                   ;00E9 <- BANK3
                        sta bank_port3                  ;00EC
			rts				;00EF
XIT_dirlp2              sta bank_port3                  ;00F0 -> 00F6
			jsr iecsecond                   ;00F3 <- BANK3
                        sta bank_port3                  ;00F6
			rts				;00F9
monitor                 sta bank_port3                  ;00FA
manager                 sta bank_port2                  ;00FD
			.text "IDE64"			;0100
			.text "64"			;0105
			jsr LWNO_set_new314vect         ;0107 <- BANK3
                        sta bank_port3                  ;010A
newconsole              sta bank_port3                  ;010D
newload                 sta bank_port1                  ;0110
newread                 sta bank_port1                  ;0113
			jsr LWOP_init_c128key           ;0116 <- BANK3
                        sta bank_port3                  ;0119
			jsr OP_check_partition_selection;011C <- BANK3
                        sta bank_port3                  ;011F
			jsr OP_findunusedchannel        ;0122 <- BANK3
                        sta bank_port3                  ;0125
			jsr OP_XIT_hdinit_2             ;0128 <- BANK3
                        sta bank_port3                  ;012B
newwrite                sta bank_port1                  ;012E
			.text "!"			;0131
			jmp hackedb2                    ;0132 <- BANK3
XIT_finalize_direntry   sta bank_port2                  ;0135 -> 013B
			jmp listbank0                   ;0138 <- BANK3
XIT_find_free_flush     sta bank_port2                  ;013B -> 0141
			rts				;013E
			jmp mymisc                      ;013F <- BANK3
			.text "64"			;0142
			rts				;0144
XIT_init_drive          sta bank_port2                  ;0145 -> 014B
			jmp overt                       ;0148 <- BANK3
XIT_load_tree           sta bank_port2                  ;014B -> 0151
			rts				;014E
			.text "64"			;014F
XIT_prealloc_dir_sector sta bank_port2                  ;0151 -> 0157
			rts				;0154
			.text "64"			;0155
XIT_read_a_sector       sta bank_port2                  ;0157 -> 015D
			rts				;015A
			.text "64"			;015B
XIT_read_in_buffer      sta bank_port2                  ;015D -> 0163
			rts				;0160
			.text "64"			;0161
XIT_save_tree           sta bank_port2                  ;0163 -> 0169
			rts				;0166
			.text "64"			;0167
XIT_write_a_sector      sta bank_port2                  ;0169 -> 016F
			rts				;016C
			.text "64"			;016D
XIT_write_out_buffer    sta bank_port2                  ;016F -> 0175
			rts				;0172
			.text "64"			;0173
XIT_read_a_sector2      sta bank_port2                  ;0175 -> 017B
			rts				;0178
			.text "IDE64"			;0179
			rts				;017E
			.fi

			.if BANK=1
iecin                   sta bank_port0                  ;0000 -> 0006
			jsr append_status_dec           ;0003 <- BANK0
exitbank0               sta bank_port0                  ;0006
			rts				;0009
ieclisten               sta bank_port0                  ;000A -> 0010
			jsr call_setup                  ;000D <- BANK0
                        sta bank_port0                  ;0010
			rts				;0013
iecout                  sta bank_port0                  ;0014 -> 001A
			jsr LWOP_disk_status            ;0017 <- BANK0
                        sta bank_port0                  ;001A
			rts				;001D
iectalk                 sta bank_port0                  ;001E -> 0024
			jsr LWOP_get_cmos_setup         ;0021 <- BANK0
                        sta bank_port0                  ;0024
			rts				;0027
iectksa                 sta bank_port0                  ;0028 -> 002E
			jsr LWOP_read_clock             ;002B <- BANK0
                        sta bank_port0                  ;002E
			rts				;0031
iecunlisten             sta bank_port0                  ;0032 -> 0038
			jsr OP_atapi_command            ;0035 <- BANK0
                        sta bank_port0                  ;0038
			rts				;003B
iecuntalk               sta bank_port0                  ;003C -> 0042
			jsr OP_atapi_packet             ;003F <- BANK0
                        sta bank_port0                  ;0042
			rts				;0045
iecsecond               sta bank_port0                  ;0046 -> 004C
			jsr OP_copy_filename_to_path    ;0049 <- BANK0
                        sta bank_port0                  ;004C
			rts				;004F
jiffy_f0d8              sta bank_port0                  ;0050 -> 0056
			jsr OP_load_loading_end         ;0053 <- BANK0
                        sta bank_port0                  ;0056
			rts				;0059
OP_check_partition_selection sta bank_port0                  ;005A -> 0060
			jsr OP_save_saving              ;005D <- BANK0
                        sta bank_port0                  ;0060
			rts				;0063
set_power_management_and_features sta bank_port0                  ;0064 -> 006A
			jsr OP_XIT_resolv_path_part     ;0067 <- BANK0
                        sta bank_port0                  ;006A
			rts				;006D
OP_read_to_direntry     sta bank_port3                  ;006E -> 0074
			jsr OP_atapi_datain_command     ;0071 <- BANK0
                        sta bank_port0                  ;0074
			rts				;0077
			.text "64"			;0078
			jsr append_status_dec           ;007A <- BANK3
exitbank3               sta bank_port3                  ;007D
pclink_load             sta bank_port3                  ;0080 -> 0086
			.text "IDE64"			;0083
			.text "!"			;0088
			rts				;0089
			.text "64"			;008A
			jsr LWOP_disk_status            ;008C <- BANK3
                        sta bank_port3                  ;008F
XIT_dir_first           sta bank_port3                  ;0092 -> 0098
			.text "IDE64"			;0095
			.text "!"			;009A
			rts				;009B
			.text "64"			;009C
			jsr LWOP_read_clock             ;009E <- BANK3
                        sta bank_port3                  ;00A1
monitor                 sta bank_port3                  ;00A4
			.text "C64"			;00A7
XIT_dirlp2              sta bank_port3                  ;00AA -> 00B0
			jsr append_status_dec           ;00AD <- BANK2
exitbank2               sta bank_port2                  ;00B0
			rts				;00B3
check_drive             sta bank_port2                  ;00B4 -> 00BA
			jsr is_special_s                ;00B7 <- BANK2
                        sta bank_port2                  ;00BA
			rts				;00BD
find_free_sectors_tree  sta bank_port2                  ;00BE -> 00C4
			jsr LWOP_disk_status            ;00C1 <- BANK2
                        sta bank_port2                  ;00C4
			rts				;00C7
linearaccess            sta bank_port2                  ;00C8 -> 00CE
			jsr OP_delimiter_in_path        ;00CB <- BANK2
                        sta bank_port2                  ;00CE
			rts				;00D1
XIT_init_drive          sta bank_port2                  ;00D2 -> 00D8
			jsr OP_get_partnum              ;00D5 <- BANK2
                        sta bank_port2                  ;00D8
			rts				;00DB
XIT_load_tree           sta bank_port2                  ;00DC -> 00E2
			jsr OP_short_path               ;00DF <- BANK2
                        sta bank_port2                  ;00E2
			rts				;00E5
XIT_read_a_sector       sta bank_port2                  ;00E6 -> 00EC
			jsr OP_XIT_partnum_delimiter    ;00E9 <- BANK2
                        sta bank_port2                  ;00EC
			rts				;00EF
XIT_save_tree           sta bank_port2                  ;00F0 -> 00F6
			jsr OP_XIT_resolv_path          ;00F3 <- BANK2
                        sta bank_port2                  ;00F6
			rts				;00F9
			.text "C64"			;00FA
			jsr OP_short_path               ;00FD <- BANK3
                        sta bank_port3                  ;0100
			jsr check_wildcards             ;0103 <- BANK3
                        sta bank_port3                  ;0106
XIT_upload_next_sector  sta bank_port2                  ;0109 -> 010F
			jsr OP_XIT_resolv_path_part     ;010C <- BANK2
                        sta bank_port2                  ;010F
			rts				;0112
			jmp newload                     ;0113 <- BANK0
			jmp newread                     ;0116 <- BANK0
			.text "IDE64"			;0119
			.text "IDE64"			;011E
			.text "IDE64"			;0123
			.text "IDE64"			;0128
			.text "SOCI"			;012D
			jmp newwrite                    ;0131 <- BANK0
			.text "!"			;0134
			jsr check_wildtype              ;0135 <- BANK3
                        sta bank_port3                  ;0138
			jsr OP_path_searchtype          ;013B <- BANK3
                        sta bank_port3                  ;013E
			.text "SOCI"			;0141
			jsr OP_save_saving              ;0145 <- BANK3
                        sta bank_port3                  ;0148
			jsr OP_XIT_resolv_path_part     ;014B <- BANK3
                        sta bank_port3                  ;014E
			jsr OP_load_loading             ;0151 <- BANK3
                        sta bank_port3                  ;0154
			.fi

			.if BANK=2
channel15_cont          sta bank_port3                  ;0000 -> 0006
			jsr numtoasc16                  ;0003 <- BANK3
exitbank3               sta bank_port3                  ;0006
			rts				;0009
getcconv                sta bank_port3                  ;000A -> 0010
			jsr XIT_init_drive              ;000D <- BANK3
                        sta bank_port3                  ;0010
			rts				;0013
			.text "C64"			;0014
			jsr XIT_init_drive2             ;0017 <- BANK3
                        sta bank_port3                  ;001A
			jsr XIT_upload_next_sector      ;001D <- BANK3
                        sta bank_port3                  ;0020
			.text "IDE64"			;0023
			.text "IDE64"			;0028
			.text "IDE64"			;002D
			.text "IDE64"			;0032
			.text "IDE64"			;0037
			.text "IDE64"			;003C
			.text "IDE64"			;0041
			.text "IDE64"			;0046
			.text "IDE64"			;004B
			.text "IDE64"			;0050
			.text "IDE64"			;0055
			.text "IDE64"			;005A
			.text "IDE64"			;005F
			.text "IDE64"			;0064
			.text "IDE64"			;0069
LWOP_timestamp          sta bank_port0                  ;006E -> 0074
			.text "IDE64"			;0071
			.text "!"			;0076
			rts				;0077
OP_check_partition_selection sta bank_port0                  ;0078 -> 007E
			jsr check_drive                 ;007B <- BANK0
exitbank0               sta bank_port0                  ;007E
			rts				;0081
OP_init_buffer_pointers sta bank_port0                  ;0082 -> 0088
			jsr find_free_sector            ;0085 <- BANK0
                        sta bank_port0                  ;0088
			rts				;008B
OP_XIT_init_filesystem_from_disk sta bank_port0                  ;008C -> 0092
			jsr OP_XIT_do_command_channel   ;008F <- BANK0
                        sta bank_port0                  ;0092
			rts				;0095
search_buffer_A         sta bank_port0                  ;0096 -> 009C
			jsr OP_XIT_execute_15command_open;0099 <- BANK0
                        sta bank_port0                  ;009C
			rts				;009F
XIT_flush_buf           sta bank_port0                  ;00A0 -> 00A6
			jsr rewrite_file                ;00A3 <- BANK0
                        sta bank_port0                  ;00A6
			rts				;00A9
append_status_dec       sta bank_port1                  ;00AA -> 00B0
			jsr update_filelen              ;00AD <- BANK0
                        sta bank_port0                  ;00B0
			rts				;00B3
is_special_s            sta bank_port1                  ;00B4 -> 00BA
			jsr check_drive                 ;00B7 <- BANK1
exitbank1               sta bank_port1                  ;00BA
			rts				;00BD
LWOP_disk_status        sta bank_port1                  ;00BE -> 00C4
			jsr find_free_sectors_tree      ;00C1 <- BANK1
                        sta bank_port1                  ;00C4
			rts				;00C7
OP_delimiter_in_path    sta bank_port1                  ;00C8 -> 00CE
			jsr linearaccess                ;00CB <- BANK1
                        sta bank_port1                  ;00CE
			rts				;00D1
OP_get_partnum          sta bank_port1                  ;00D2 -> 00D8
			jsr XIT_init_drive              ;00D5 <- BANK1
                        sta bank_port1                  ;00D8
			rts				;00DB
OP_short_path           sta bank_port1                  ;00DC -> 00E2
			jsr XIT_load_tree               ;00DF <- BANK1
                        sta bank_port1                  ;00E2
			rts				;00E5
OP_XIT_partnum_delimiter sta bank_port1                  ;00E6 -> 00EC
			jsr XIT_read_a_sector           ;00E9 <- BANK1
                        sta bank_port1                  ;00EC
			rts				;00EF
OP_XIT_resolv_path      sta bank_port1                  ;00F0 -> 00F6
			jsr XIT_save_tree               ;00F3 <- BANK1
                        sta bank_port1                  ;00F6
			rts				;00F9
			.text "IDE64"			;00FA
			.text "!"			;00FF
			jmp manager                     ;0100 <- BANK0
			.text "IDE64"			;0103
			.text "!"			;0108
OP_XIT_resolv_path_part sta bank_port1                  ;0109 -> 010F
			jsr XIT_upload_next_sector      ;010C <- BANK1
                        sta bank_port1                  ;010F
			rts				;0112
			.text "IDE64"			;0113
			.text "IDE64"			;0118
			.text "IDE64"			;011D
			.text "IDE64"			;0122
			.text "IDE64"			;0127
			.text "IDE64"			;012C
			.text "IDE64"			;0131
			.text "64"			;0136
			jsr XIT_finalize_direntry       ;0138 <- BANK0
                        sta bank_port0                  ;013B
			jsr XIT_find_free_flush         ;013E <- BANK0
                        sta bank_port0                  ;0141
			.text "SOCI"			;0144
			jsr XIT_init_drive              ;0148 <- BANK0
                        sta bank_port0                  ;014B
			jsr XIT_load_tree               ;014E <- BANK0
                        sta bank_port0                  ;0151
			jsr XIT_prealloc_dir_sector     ;0154 <- BANK0
                        sta bank_port0                  ;0157
			jsr XIT_read_a_sector           ;015A <- BANK0
                        sta bank_port0                  ;015D
			jsr XIT_read_in_buffer          ;0160 <- BANK0
                        sta bank_port0                  ;0163
			jsr XIT_save_tree               ;0166 <- BANK0
                        sta bank_port0                  ;0169
			jsr XIT_write_a_sector          ;016C <- BANK0
                        sta bank_port0                  ;016F
			jsr XIT_write_out_buffer        ;0172 <- BANK0
                        sta bank_port0                  ;0175
			jsr XIT_read_a_sector2          ;0178 <- BANK0
                        sta bank_port0                  ;017B
			.fi

			.if BANK=3
numtoasc16              sta bank_port2                  ;0000 -> 0006
			jsr channel15_cont              ;0003 <- BANK2
exitbank2               sta bank_port2                  ;0006
			rts				;0009
XIT_init_drive          sta bank_port2                  ;000A -> 0010
			jsr getcconv                    ;000D <- BANK2
                        sta bank_port2                  ;0010
			rts				;0013
XIT_init_drive2         sta bank_port2                  ;0014 -> 001A
			.text "C64"			;0017
XIT_upload_next_sector  sta bank_port2                  ;001A -> 0020
			rts				;001D
			.text "IDE64"			;001E
			rts				;0023
			.text "IDE64"			;0024
			.text "IDE64"			;0029
			.text "IDE64"			;002E
			.text "IDE64"			;0033
			.text "IDE64"			;0038
			.text "IDE64"			;003D
			.text "IDE64"			;0042
			.text "IDE64"			;0047
			.text "IDE64"			;004C
			.text "IDE64"			;0051
			.text "IDE64"			;0056
			.text "IDE64"			;005B
			.text "IDE64"			;0060
			.text "IDE64"			;0065
			.text "IDE64"			;006A
			.text "64"			;006F
			jsr OP_read_to_direntry         ;0071 <- BANK1
exitbank1               sta bank_port1                  ;0074
append_status_dec       sta bank_port1                  ;0077 -> 007D
			.text "IDE64"			;007A
			.text "!"			;007F
			rts				;0080
			.text "64"			;0081
			jsr pclink_load                 ;0083 <- BANK1
                        sta bank_port1                  ;0086
LWOP_disk_status        sta bank_port1                  ;0089 -> 008F
			.text "IDE64"			;008C
			.text "!"			;0091
			rts				;0092
			.text "64"			;0093
			jsr XIT_dir_first               ;0095 <- BANK1
                        sta bank_port1                  ;0098
LWOP_read_clock         sta bank_port1                  ;009B -> 00A1
			.text "IDE64"			;009E
			.text "!"			;00A3
			rts				;00A4
			.text "64"			;00A5
			jmp monitor                     ;00A7 <- BANK1
iecin                   sta bank_port0                  ;00AA -> 00B0
			jsr XIT_dirlp2                  ;00AD <- BANK1
                        sta bank_port1                  ;00B0
			rts				;00B3
ieclisten               sta bank_port0                  ;00B4 -> 00BA
			jsr cdrom_idleoff               ;00B7 <- BANK0
exitbank0               sta bank_port0                  ;00BA
			rts				;00BD
iecout                  sta bank_port0                  ;00BE -> 00C4
			jsr pclink_chrin                ;00C1 <- BANK0
                        sta bank_port0                  ;00C4
			rts				;00C7
iectalk                 sta bank_port0                  ;00C8 -> 00CE
			jsr pclink_close                ;00CB <- BANK0
                        sta bank_port0                  ;00CE
			rts				;00D1
iectksa                 sta bank_port0                  ;00D2 -> 00D8
			jsr pclink_open                 ;00D5 <- BANK0
                        sta bank_port0                  ;00D8
			rts				;00DB
iecunlisten             sta bank_port0                  ;00DC -> 00E2
			jsr pclink_save                 ;00DF <- BANK0
                        sta bank_port0                  ;00E2
			rts				;00E5
iecuntalk               sta bank_port0                  ;00E6 -> 00EC
			jsr XIT_dir_first               ;00E9 <- BANK0
                        sta bank_port0                  ;00EC
			rts				;00EF
iecsecond               sta bank_port0                  ;00F0 -> 00F6
			jsr XIT_dirlp2                  ;00F3 <- BANK0
                        sta bank_port0                  ;00F6
			rts				;00F9
OP_short_path           sta bank_port1                  ;00FA -> 0100
			jmp monitor                     ;00FD <- BANK0
check_wildcards         sta bank_port1                  ;0100 -> 0106
			rts				;0103
LWNO_set_new314vect     sta bank_port0                  ;0104 -> 010A
			.text "64"			;0107
			rts				;0109
			.text "C64"			;010A
			rts				;010D
			.text "64"			;010E
			jmp newconsole                  ;0110 <- BANK0
LWOP_init_c128key       sta bank_port0                  ;0113 -> 0119
			.text "C64"			;0116
OP_check_partition_selection sta bank_port0                  ;0119 -> 011F
			rts				;011C
			.text "64"			;011D
OP_findunusedchannel    sta bank_port0                  ;011F -> 0125
			rts				;0122
			.text "64"			;0123
OP_XIT_hdinit_2         sta bank_port0                  ;0125 -> 012B
			rts				;0128
			.text "IDE64"			;0129
			rts				;012E
hackedb2                sta bank_port0                  ;012F
check_wildtype          sta bank_port1                  ;0132 -> 0138
listbank0               sta bank_port0                  ;0135
OP_path_searchtype      sta bank_port1                  ;0138 -> 013E
			rts				;013B
mymisc                  sta bank_port0                  ;013C
			.text "64"			;013F
			rts				;0141
OP_save_saving          sta bank_port1                  ;0142 -> 0148
overt                   sta bank_port0                  ;0145
OP_XIT_resolv_path_part sta bank_port1                  ;0148 -> 014E
			rts				;014B
			.text "64"			;014C
OP_load_loading         sta bank_port1                  ;014E -> 0154
			rts				;0151
			.text "IDE64"			;0152
			rts				;0157
			.fi

